;    Adapted by Einar Saukas
;    Based on previous program by Flavio Matsumoto
;    Includes delay routine by Jan Bobrowski

;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.

;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.

;    You should have received a copy of the GNU General Public License
;    along with this program.  If not, see <http://www.gnu.org/licenses/>.

        ORG 40000
VTMain:
        ; Load delay value
        LD DE,5000

        ; Setup an "empty" IM2 routine
        LD A,$18            ; opcode for "JR" (12T)
        LD ($FFFF),A
        LD HL,$C9FB         ; opcodes for "EI" (4T) and "RET" (10T)
        LD ($FFF4),HL

        ; Enable IM 2
        DI
        LD A,$3B
        LD I,A
        IM 2
        EI

VTStart:
        ; Change attributes some time after next interrupt
        HALT                ; Wait for the maskable interrupt (0 to 3T)
        LD HL,$5820         ; Attribute position AT 1,0; (10T)
        LD (HL),2           ; set INK 2 (10T)
        LD B,D              ; Copy delay value to BC (4T)
        LD C,E              ; Copy delay value to BC (4T)
        CALL DELAY          ; configurable delay
        LD HL,$5820         ; Attribute position AT 1,0; (10T)
        LD BC,$0701         ; INK 7 and INK 2 (10T)
        LD (HL),B           ; set INK 7 (7T)
        LD (HL),C           ; set INK 1 (7T)

        ; Synchronize with TV raster beam (see Rotatrix documentation)
        LD B,6
VTSync:
        LD A,($4000)
        DJNZ VTSync

        ; Now "force" a variable but controlled delay before the next HALT
VTDelay:
        LD HL,0
        LD BC,25
        ADD HL,BC
        LD (VTDelay+1),HL
        LD B,H
VTLoop:
        DJNZ VTLoop

        ; Check for pressed key
        LD BC,254           ; B signals to read all keys, C is port address.
        IN A,(C)            ; Read keyboard.
        CPL                 ; If no keys pressed,
        AND %011111
        JR Z,VTStart        ; then repeat for next frame

        ; Disable visual effect
        LD HL,$5820         ; Attribute position AT 1,0;
        LD (HL),0           ; set INK 0

        ; Disable IM 2
        DI
        LD A,$3F
        LD I,A
        IM 1
        EI
        RET

#include "delay.asm"
